(function ($, Drupal) {
  Drupal.behaviors.imageSizesBehavior = {
    attach: function (context, settings) {

      $('img.image-sizes', context).once('imageSizesBehaviorLoad').each(function () {
        if (!$(this).data('image-sizes')) {
          $(this).data('image-sizes', JSON.parse($(this).attr('data-src')));
        }
        $(this).on('image:size-check', function() {
          imageSizesSetUrl(this);
        });
      });

      $.map($('img.image-sizes', context),function(ele){
        var parent = $(ele).parent();
        new ResizeSensor(parent, function() {
          parent.find('> img.image-sizes').each(function(){
            if ($(this).visible(true)) {
              imageSizesSetUrl(this);
            }
          })
        });
      });

      $(window).on('scroll resize scrollstop image:screen-check', init);

      $(window).scroll();
    }
  };
  function init() {
    $('img.image-sizes').each(function(){
      if ($(this).visible(true)) {
        imageSizesSetUrl(this);
      }
    });
  }
  function imageSizesSetUrl(ele) {
    var width = $(ele).parent().width();
    var conf = $(ele).data('image-sizes');
    var newUrl = false;
    var a;
    for ( var a in conf ) {
      newUrl = conf[a];
      if (a >= width) {
        break;
      }
    }
    if (width > a || newUrl == false) {
      newUrl = $(ele).attr('data-src-fallback');
    }
    if (newUrl !== ele.src) {
      let img = new Image();
      $(ele).addClass('loading');
      $(img).on('load', function() {
        $(ele).removeClass('pre-load').removeClass('loading').addClass('fade-in-on-load');
        ele.src = this.src;
        $(ele).trigger('image:size-checked');
        delete this;
      });

      img.src = newUrl;
    }
  }
})(jQuery, Drupal);
